%bcond_with dune
%global debug_package %{nil}

Summary:        Parsing and printing of S-expressions in canonical form
Name:           ocaml-csexp
Version:        1.5.2
Release:        5%{?dist}

License:        MIT
URL:            https://github.com/ocaml-dune/csexp
Source0:        %{url}/releases/download/%{version}/csexp-%{version}.tbz

BuildRequires:  ocaml >= 4.03.0
%if %{with dune}
BuildRequires:  ocaml-dune >= 1.11
%else
BuildRequires:  python3
%endif

%description
This project provides minimal support for parsing and printing
S-expressions in canonical form, which is a very simple and canonical
binary encoding of S-expressions.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%autosetup -n csexp-%{version}

%build
%if %{with dune}
%dune_build
%else
OFLAGS="-w -40 -g"
OCFLAGS="$OFLAGS -bin-annot"
cd src
ocamlc $OCFLAGS -no-alias-deps -o csexp.cmi -c -intf csexp.mli
ocamlc $OCFLAGS -intf-suffix .ml -no-alias-deps -o csexp.cmo -c -impl csexp.ml
ocamlc $OFLAGS -a -o csexp.cma csexp.cmo
ocamlopt $OFLAGS -intf-suffix .ml -no-alias-deps -o csexp.cmx -c -impl csexp.ml
ocamlopt $OFLAGS -a -o csexp.cmxa csexp.cmx
ocamlopt $OFLAGS -shared -linkall -I . -o csexp.cmxs csexp.cmxa
%endif

%install
%if %{with dune}
%dune_install
%else
mkdir -p %{buildroot}%{_libdir}/ocaml/csexp
cp -p src/csexp.{cma,cmi,cmt,cmti,mli} %{buildroot}%{_libdir}/ocaml/csexp
cp -p src/csexp.{a,cmx,cmxa,cmxs} %{buildroot}%{_libdir}/ocaml/csexp
cp -p csexp.opam %{buildroot}%{_libdir}/ocaml/csexp/opam

cat >> %{buildroot}%{_libdir}/ocaml/csexp/META << EOF
version = "%{version}"
description = "Parsing and printing of S-expressions in canonical form"
requires = ""
archive(byte) = "csexp.cma"
archive(native) = "csexp.cmxa"
plugin(byte) = "csexp.cma"
plugin(native) = "csexp.cmxs"
EOF

cat >> %{buildroot}%{_libdir}/ocaml/csexp/dune-package << EOF
(lang dune 3.7)
(name csexp)
(version %{version})
(sections (lib .) (libexec .) (doc ../../doc/csexp))
(files
 (lib
  (META
   csexp.a
   csexp.cma
   csexp.cmi
   csexp.cmt
   csexp.cmti
   csexp.cmx
   csexp.cmxa
   csexp.ml
   csexp.mli
   dune-package
   opam))
 (libexec (csexp.cmxs))
 (doc (CHANGES.md LICENSE.md README.md)))
(library
 (name csexp)
 (kind normal)
 (archives (byte csexp.cma) (native csexp.cmxa))
 (plugins (byte csexp.cma) (native csexp.cmxs))
 (native_archives csexp.a)
 (main_module_name Csexp)
 (modes byte native)
 (modules
  (singleton
   (obj_name csexp)
   (visibility public)
   (source (path Csexp) (intf (path csexp.mli)) (impl (path csexp.ml))))))
EOF

%endif

%files
%license LICENSE.md
%doc README.md
%dir %{_libdir}/ocaml/csexp/
%{_libdir}/ocaml/csexp/META
%{_libdir}/ocaml/csexp/*.cma
%{_libdir}/ocaml/csexp/*.cmi
%{_libdir}/ocaml/csexp/*.cmxs

%files devel
%{_libdir}/ocaml/csexp/dune-package
%{_libdir}/ocaml/csexp/opam
%{_libdir}/ocaml/csexp/*.a
%{_libdir}/ocaml/csexp/*.cmx
%{_libdir}/ocaml/csexp/*.cmxa
%{_libdir}/ocaml/csexp/*.cmt
%{_libdir}/ocaml/csexp/*.cmti
%{_libdir}/ocaml/csexp/*.mli

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.5.2-5
- Rebuilt for OpenCloudOS Stream 23.09

* Tue Aug 08 2023 cunshunxia <cunshunxia@tencent.com> - 1.5.2-4
- rebuild for ocaml 5.0

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.5.2-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.5.2-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Mar 31 2023 cunshunxia <cunshunxia@tencent.com> - 1.5.2-1
- initial build
